﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace XmlTree
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        XmlDocument doc;

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            propertyGrid1.SelectedObject = e.Node.Tag; // <--
        }

        private void showAttributes (TreeNodeCollection target, XmlNode node)
        {
            if (node.Attributes != null)
               foreach (XmlAttribute a in node.Attributes)
               {
                   TreeNode item = new TreeNode();
                   item.Tag = a; 
                   item.Text = "attr: " + a.Name + " = " + a.Value;
                   item.ForeColor = Color.Blue;
                   target.Add(item);
               }
        }

        private void showNode(TreeNodeCollection target, XmlNode node)
        {
            TreeNode item = new TreeNode();
            item.Tag = node; 
            if (node.NodeType == XmlNodeType.Text)
                item.Text = "text: " + node.InnerText;
            else
                item.Text = node.Name;
            target.Add (item);

            showAttributes (item.Nodes, node); // <--

            foreach (XmlNode n in node.ChildNodes)
                showNode (item.Nodes, n);
        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                doc = new XmlDocument();
                doc.Load (openFileDialog1.FileName);

                XmlElement elem = doc.DocumentElement;
                propertyGrid1.SelectedObject = elem;
                showNode (treeView1.Nodes, elem);
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                doc.Save(saveFileDialog1.FileName);
        }

        private void treeView1_NodeMouseDoubleClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            TreeNode item = e.Node;
            if (item.Tag is XmlElement)
            {
                XmlElement elem = item.Tag as XmlElement;
                XmlElement t = doc.CreateElement ("test");
                for (int i = 1; i <= 3; i++)
                {
                    XmlElement u = doc.CreateElement("subitem");
                    t.AppendChild (u);
                    XmlAttribute a = doc.CreateAttribute("index");
                    a.Value = "" + i;
                    u.Attributes.Append(a);
                }
                elem.AppendChild (t);
                showNode (item.Nodes, t);
            }
        }

    }
}
